package Comment_WL;
#...................................................................#
# Sanitarium WebLoG: web publish system.............................#
# Author: Green Kakadu (WebScript.Ru Network) ......................#
# Email: gnezdo@webscript.ru .......................................#
# WWW: http://webscript.ru .........................................#
# Copyright 2002 WebScript.Ru Network ( http://webscript.ru ).......#
# All Rights Reserved. .............................................#
#...................................................................#

#...................................................................#
#file: Comment_WL.pm - class for work with flat text db             #
#...................................................................#
use Carp;
use strict;
use Fcntl;
use vars '@db', '$delim', '$ascii_delim', '$USE_FLOCK';

#$delim - DB field separate symbol
 $delim= '|';
#$ascii_delim, ANSII eq your $delim symbol, synopsis: &#$ascii_delim - for html
 $ascii_delim='&#124';

@db=('id','status','name', 'mail', 'www','ip','date', 'content', 'admin_answer');
#################################################################
# ID|status|name|mail|www|ip|date|content|admin_answer
#################################################################
#flock() option:
$USE_FLOCK=1;


sub new {
#---------------------------------------------------
my $self={};
shift;
$self->{DB_FILE}=shift;
bless $self;
return $self;
}	

sub add_new {
#--------------------------------------------------
my $self=shift;
$self->_to_self(@_);
my $rec=$self->pack_fields();
&_open(">>$self->{DB_FILE}",2);
print COMM "$rec\n";
&_close;
}

sub modify {
#-------------------------------------------------
my $self=shift;
my $id=shift;
my %new=@_;
my $i=0;
&_open( "<$self->{DB_FILE}",1);
my @recs=<COMM>;
&_close;
foreach my $rec(@recs){
	if ($rec !~/^$id\Q$delim\E/o){
		$i++;
		next;
	}
	$self->unpack_rec($rec);
	foreach my $key(keys %new){
		$self->{$key}=$new{$key};
	}
	$recs[$i]=$self->pack_fields();
	$recs[$i] .="\n";
	last;
}
&_open(">$self->{DB_FILE}",2);
print COMM @recs;
&_close;
}	

sub del_it {
#-------------------------------------------------
my $self=shift;
my $id=shift;
my $new=0;
&_open("<$self->{DB_FILE}",1);
my @recs=<COMM>;
&_close;
foreach my $rec(@recs){
	if ($rec =~m/^$id\Q$delim\E/o){next;}
	$new .=$rec;
}
&_open(">$self->{DB_FILE}",2);
print COMM $new;
&_close;
}	

sub get_me_recs {
#--------------------------------------------------
my $self=shift;
&_open("<$self->{DB_FILE}",1);
my @recs=<COMM>;
&_close;
return @recs;
}

sub get_data {
#-------------------------------------------------
my $self=shift;
my $id=shift;
&_open("<$self->{DB_FILE}",1);
my @recs=<COMM>;
&_close;
foreach my $rec(@recs){
	unless ($rec=~m/^$id\Q$delim\E/o){next;}
	return $self->unpack_to_hash($rec);
}
return 0;
}	

########  OPEN/CLOSE

sub _open {
#---------------------------------------------------
my $file=shift;
my $flock=shift;
open (COMM, $file)||croak("Can not open $file, reason:$!");
if ($USE_FLOCK){flock(COMM, $flock) or croak("Can not flock COMM, reason:$!");}
}	

sub _close {
#---------------------------------------------------
close (COMM)||croak("Can not close COMM, reason:$!");
}

##########  PACK/UNPACK

sub pack_rec {
#--------------------------------------------------
my $self=shift;
my (@rec);
my @vals=@_;
unless ($#_ == $#db){croak ("Not found some data for fields db!")}
foreach my $val(@vals){
$val=~s/\Q$delim\E/$ascii_delim/og;
$val=&no_n_r($val);
push (@rec, $val);
}	 
return join($delim, @rec);
}

sub pack_fields {
#-------------------------------------------------
my $self=shift;
my (@rec, $field);
foreach $field (@db){
	push (@rec, $self->{$field});
}
return $self->pack_rec(@rec);
}
	
sub unpack_rec {
#-------------------------------------------------
my $self=shift;
my $pack_rec=shift;
my @rec=split (/\Q$delim\E/, $pack_rec);
$self->_self_fields(@rec);
} 

sub unpack_to_hash {
#-----------------------------------------------
my $self=shift;
$self->unpack_rec($_[0]);
return $self->self_to_hash;
}	

sub unpack_field {
#------------------------------------------------
my $self=shift;
my $recs=shift;
my $field=shift;
my %all_recs=$self->unpack_to_hash($recs);
return 	$all_recs{$field};
}

########## SELF METHODS

sub _to_self {
#-------------------------------------------------
my $self=shift;
my %rec=@_;
foreach my $key (keys %rec){
	$self->{$key}=$rec{$key};
}	
}	

sub _self_fields {
#------------------------------------------------
my $self=shift;
my ($i, $field);
$i=0;
foreach $field (@db){
$_[$i]||='';
$self->{$field}=$_[$i];
$i++;
}
}

sub self_to_hash {
#--------------------------------------------------
my $self=shift;
my ($field, %data);
foreach $field (@db){
$data{$field}=$self->{$field};
}
return %data;
}

sub no_n_r {
#---------------------------------------------------
my $val=shift;
$val=~s/[\n\r]//g;
return $val;
}
	
	

sub DESTROY {
#----------------------------------------------
}	
	
1;
