package Sanitarium_WL;
#.......................................................................#
# Sanitarium WebLoG: web publish system.................................#
# Author: Green Kakadu (WebScript.Ru Network) ..........................#
# Email: gnezdo@webscript.ru ...........................................#
# WWW: http://webscript.ru .............................................#
# Copyright 2002 WebScript.Ru Network ( http://webscript.ru )...........#
# All Rights Reserved. .................................................#
#.......................................................................#

#	Just like a curse, just like a stray
#	You feed it once and now it stays
#	Now it stays
#...................	Metallica, "Until it Sleeps" 

#.................................................................................#
# File name: Sanitarium_WL.pm - Class for manipulate with Sanitarium WebLog Data..#
#.................................................................................#

use Carp qw(croak);
use DB_File;
$DB_HASH->{'bsize'} =512;# Now set bucket size = 4kb 
#$DB_HASH->{'ffactor'} = 16;
use Fcntl;
use strict;
use vars '%db', '$delim', '$ascii_delim', '%dbm', '%article_db', '$USE_FLOCK';

 %db = (
	'categories'  =>['cat_name', 'cat_description', 'cat_keywords', 'template'],
	'index'       =>['title', 'preview', 'cat_id', 'author', 'id', 'date', 'pages', 'status'],
	'authors'     =>['name', 'mail', 'signatures', 'foto', 'www'],
	'article'     =>['cat_id', 'title', 'date', 'author', 'preview', 'content', 'keywords', 'num', 'pages', 'related']);

#$delim - DB field separate symbol
 $delim= '|';
#$ascii_delim, ANSII eqiv your $delim symbol, example: &#$ascii_delim - for html
 $ascii_delim='&#124';
 #flock() option
 $USE_FLOCK=1;


sub new {
#---------------------------------------------------
my $self={};
shift;
$self->{DB_File}=shift;
$self->{DB_Field}=shift;
bless $self;
return $self;
}	

###################################################
#  MAIN! Working whith DB: create/modify/delete   #                
###################################################

sub write_data {
#--------------------------------------------------
my $self=shift;
my $id=shift;
my $pack_rec;
if (@_){$pack_rec=$self->pack_rec(@_);}
else {croak "write_data: You must get data! \@_ empty!";}
#open dbm 
$self-> _open_db(1, 2);
#Check Duplicate Key
if ($id=~/(\d+)cat/){
    $id=$1;
	while (exists $dbm{$id}){$id++;}
}	
elsif ($id=~/(\d+)auth/){
	while (exists $dbm{$id}){
			my $end =($1+1);
	    	$id=~s/$1/$end/;
	}
}
else {croak("Dublicate key: $id!") if (exists $dbm{$id});}

#Write new record to dbm 
$dbm{$id}=$pack_rec;
#close dbm
&_close_db;
return $id;
}

sub modify_data {
#--------------------------------------------------
my $self=shift;
$self->{DB_Key}=shift;
my $pack_rec;
if (@_){$pack_rec=$self->pack_rec(@_);}
else {croak "write_data: You must get data! \@_ empty!";}
#open dbm 
$self-> _open_db(2, 2);
if (exists $dbm{$self->{DB_Key}}){
	#Write new record to dbm 
	$dbm{$self->{DB_Key}}=$pack_rec;
	#close dbm
	&_close_db;
}
else {
	croak("Key $self->{DB_Key}, not exists! Modify failed!");	
}
}

sub add_entry {
#-------------------------------------------------
my $self=shift;
my $id=shift;
my $pack_rec;
if (@_){$pack_rec=$self->pack_rec(@_);}
else {croak "write_data: You must get data! \@_ empty!";}
#$DB_HASH->{'nelem'}=1;# hog some disk space for the future
#open dbm 
$self-> _open_db(1, 2);

$dbm{$id}=$pack_rec;
#close dbm
&_close_db;
}	

sub delete_data {
#--------------------------------------------------
my $self=shift;
$self->{DB_Key}=shift;
#open dbm 
$self-> _open_db(2, 2);
if (exists $dbm{$self->{DB_Key}}){
	#delete data
	delete $dbm{$self->{DB_Key}};
	&_close_db;
}
else { croak("Key $self->{DB_Key} not exists! DELETE failed!");}	
}	

sub modify_fields {
#-----------------------------------------------
my $val;
my $self=shift;
$self->{DB_Key}=shift;
my ($i, $rec);
$self-> _open_db(2, 2);
$self->unpack_rec($dbm{$self->{DB_Key}});
for ($i=0; $i<=$#_; $i +=2){
	if ($_[$i+1]=~/$_[$i]\+\+/){$val=$self->{$_[$i]}; $val+=1; $self->{$_[$i]}=$val;}
	elsif ($_[$i+1]=~/$_[$i]--/){$val=$self->{$_[$i]}; $val-=1; $self->{$_[$i]}=$val;}
	elsif ($_[$i+1]=~/^$_[$i]:push=(\w+)$/){$val=$self->{$_[$i]}; $val .=";;$1"; $self->{$_[$i]}=$val;}
	elsif ($_[$i+1]=~/^$_[$i]:pop=(\w+)$/){
	$val=$self->{$_[$i]}; $val=~s/$1//g; 
	$val=~s/;;((;;)+)/;;/g; $self->{$_[$i]}=$val;
	}
	else {$self->{$_[$i]}=$_[$i+1];}
}
$rec=$self->pack_fields();
$dbm{$self->{DB_Key}}=$rec;
&_close_db();
} 	

sub modify_all_recs {
#---------------------------------------------------
my $val;
my $self=shift;
my @fields=@_;
my ($i, $rec);
$self->_open_db(2, 2);
my @keys=keys %dbm;
foreach my $key(@keys){
	unless (defined $dbm{$key}){next;}
	$self->unpack_rec($dbm{$key});
	for ($i=0; $i<=$#fields; $i +=2){
		if ($fields[$i+1]=~/$fields[$i]\+\+/){$val=$self->{$fields[$i]}; $val+=1; $self->{$fields[$i]}=$val;}
		elsif ($fields[$i+1]=~/$fields[$i]--/){$val=$self->{$fields[$i]}; $val-=1; $self->{$fields[$i]}=$val;}
		elsif ($fields[$i+1]=~/^$fields[$i]:push=(\w+)$/){$val=$self->{$fields[$i]}; $val .=";;$1"; $self->{$fields[$i]}=$val;}
		elsif ($fields[$i+1]=~/^$fields[$i]:pop=(\w+)$/){
		$val=$self->{$fields[$i]}; $val=~s/$1//g; 
		$val=~s/;;((;;)+)/;;/g; $self->{$fields[$i]}=$val;
		}
		else {$self->{$fields[$i]}=$fields[$i+1];}
	}
	$rec=$self->pack_fields();
	$dbm{$key}=$rec;
	
} 	
&_close_db();
}	



sub mass_delete {
#---------------------------------------------------
my $self=shift;
my @keys=@_;
$self-> _open_db(2, 2);
foreach my $key(@keys){
	unless(defined $dbm{$key}){next;}
	delete $dbm{$key};
}
&_close_db;
}

sub create_db {
#--------------------------------------------------
my $self=shift;
$self-> _open_db(1, 2);
&_close_db;
}	
	

###################################################
#                Counter                          #
###################################################

sub get_id {
#-------------------------------------------------
my $self=shift;
#my $key=shift;
my $id;
$self->_open_db(1,2);
unless (exists $dbm{'id'}){$dbm{'id'}=0;}
$id=($dbm{'id'}+1);
$dbm{'id'}=$id;
&_close_db;
return $id;
}	


####################################################
#               Get Methods                        #
####################################################

sub get_fields {
#---------------------------------------------------
my $self=shift;
return @{$db{$self->{DB_Field}}};
}	


sub get_data {
#---------------------------------------------------
my $self=shift;
$self->{DB_Key}=shift;
$self->_open_db(3, 1);
if (exists $dbm{$self->{DB_Key}}){	
	my $data=$dbm{$self->{DB_Key}};
	&_close_db;
	$self->unpack_rec($data);
	return $self->self_to_hash;
}
else {croak("Error! Key $self->{DB_Key} not exists! GET_DATA failed!");}
}

sub check_and_get {
#---------------------------------------------------
my $self=shift;
$self->{DB_Key}=shift;
$self->_open_db(3, 1);
if (exists $dbm{$self->{DB_Key}}){	
	my $data=$dbm{$self->{DB_Key}};
	&_close_db;
	$self->unpack_rec($data);
	return $self->self_to_hash;
}
else {return 0;}
}	
	

sub get_field_data {
#----------------------------------------------------
my $self=shift;
$self->{DB_Key}=shift;
my $field=shift;
$field||(croak("Error! Key $self->{DB_Key} not exists! GET_DATA failed!"));
my %all_recs=$self->get_data($self->{DB_Key});
return $all_recs{$field};
}	

sub get_keys {
#--------------------------------------------------
my $self=shift;
$self->_open_db(3, 1);
my @keys= map {$_ if defined $dbm{$_}} keys %dbm;
&_close_db;
return @keys;
}	

sub get_num_recs {
#--------------------------------------------------
my $self=shift;
my @keys=$self->get_keys();
return $#keys;
}	

sub self_to_hash {
#--------------------------------------------------
my $self=shift;
my %data=();
%data= map {$_ => $self->{$_}} @{$db{$self->{DB_Field}}};
return %data;
}


sub get_nn_recs {
#------------------------------------------------
my $self=shift;
my $nn=shift;
my $page=shift;
my $sort=shift;#if $sort=true, than alphabetical sort, else - sort by number
my ($rec, $from, $to, @keys, %recs);
$page||=0;
if ($nn ne 'all'){
	$from = $page*$nn;
	$to = $from + $nn -1;
}	 
else {$from=0; $to=0;}
$self->_open_db(3, 1);
if ($sort){	@keys = sort {$a cmp $b} keys %dbm; }#Alphabetical sort
else { @keys = sort {$b <=> $a} keys %dbm; } #sort by number, default
if ($from > $#keys){ #if wrong $page, than get last page
	if ($#keys-$nn+1>=0){$from=$#keys;}
	else {$from=0;}
}
if (($to > $#keys)||($nn eq 'all')){$to=$#keys;}#get to the end
if ($to==$from){
	if (defined $dbm{$keys[$to]}){
		$recs{$keys[$to]} = $dbm{$keys[$to]};
		&_close_db;
		return %recs;
	}
	else {
		&_close_db;
		return 0;
	}
}	
%recs=map {$_=>$dbm{$_} if defined $dbm{$_}} @keys[$from..$to]; 
#foreach $rec (@keys[$from..$to]){
#	$recs{$rec}=$dbm{$rec} if (defined $dbm{$rec});
#}
&_close_db;
return %recs;
}


#sub get_this_recs {
#---------------------------------------------------
#my $self=shift;
#my @list=@_;
#$self->_open_db(3,1);
#my %recs=();
#%recs=map {$_=>$dbm{$_} if defined $dbm{$_}} @list;
#foreach my $rec(@list){
#	unless(defined $dbm{$rec}){next;} 
#	$recs{$rec}=$dbm{$rec};
#}		
#&_close_db;
#return %recs;	
#}	


####################################################
#                 WebLog Methods                   #
####################################################

sub delete_page {
#---------------------------------------------------
my ($num, $pages);
my $self=shift;
my $id=shift;
my $rec=shift;
$self->_open_db(2, 2);
my @keys = sort {$a <=> $b} keys %dbm;
foreach my $key(@keys){
	unless(defined $dbm{$key}){next;}
	if ($key == $rec){
	  delete $dbm{$key};#||&croak("deleting $rec failed! Reason: $!");
	 }
	elsif($key > $rec){
		$self->unpack_rec($dbm{$key});
		$num=($key-1);
		$pages=$self->{'pages'};
		$self->{'num'}=$num;
		$self->{'pages'}=($pages-1);
		$dbm{$num}=$self->pack_fields();
		delete $dbm{$key} if ($pages==$key);
	}
	elsif ($key < $rec){
		$self->unpack_rec($dbm{$key});
		$pages=$self->{'pages'};
		$self->{'pages'}=($pages-1);
		$dbm{$key}=$self->pack_fields();
	}
   	
}	
&_close_db;
}	

sub add_page {
#--------------------------------------------------
my ($num, $pages);
my $self=shift;
my $id=shift;
$self->{PAGE}=shift;
my $rec=$self->{PAGE};
$self->_open_db(2, 2);
my @keys = sort {$b <=> $a} keys %dbm;
foreach my $key (@keys) {
	unless(defined $dbm{$key}){next;}
	if($key >= $rec){
		$self->unpack_rec($dbm{$key});
		$num=($key+1);
		$pages=$self->{'pages'};
		$self->{'num'}=$num;
		$self->{'pages'}=($pages+1);
		$dbm{$num}=$self->pack_fields();
		delete $dbm{$key};
	}
	else {
		$self->unpack_rec($dbm{$key});
		$pages=$self->{'pages'};
		$self->{'pages'}=($pages+1);
	    $dbm{$key}=$self->pack_fields();
	}
   	
}	
&_close_db;
}	

sub load_cfg {
#----------------------------------------------------
my @cfg=('site_title', 'public_url','index_page','ext','index_url','entry_per_page','static_pages','data','tmpl_dir','public_dir', 'view_cgi_url', 'view_comments', 'how_news', 'txt_news','foto_url', 'cat_id', 'cat_url', 'template', 'page');	
my $self=shift;
foreach my $cfg_data(@cfg){
	my $val=shift;
	if (defined $val){$self->{$cfg_data}=$val;}
}
$self->{'print_news'}="$self->{'public_url'}/news";
$self->{'contribute'}="$self->{'view_cgi_url'}?add=1";
}	

sub build_article {
#-----------------------------------------------------
my $self=shift;
my ($id, $cat, $page_view, $print)=@_;#Get article&category data
unless ($self->{'authors_ext'}){$self->extract_authors;}
my ($html);
$cat||=$self->{'cat_id'};
$self->{'id'}=$id;
$self->{'cat_id'}=$cat;
$self->{DB_Field}='article';
$self->{'comments'}="$self->{'view_comments'}?id=$id&cat_id=$cat";
$self->{'cat_url'}="$self->{'public_url'}/$self->{'cat_id'}/$self->{'index_page'}";
$self->article_open;
my @pages= sort {$a <=> $b} map {$_ if defined $article_db{$_}} keys %article_db;

#if use dinamic generated pages
if ($page_view){
	$self->{'page'}=$page_view;
	$self->unpack_rec($article_db{$pages[($page_view - 1)]});
	#$self->get_author_info();
	if ($print){
		#make <%article_url%> for mail & print pages
		if ($self->{'static_pages'}){$self->{'article_url'}="$self->{'public_url'}/$self->{'cat_id'}/$id"."_1.$self->{'ext'}";}
		else {$self->{'article_url'}=$self->{'view_cgi_url'}."?goto=$id";}
		$self->load_templates($print);#$print = 'print' or 'mail'
		
		}
	$self->{'static_pages'}=0;	
	return $self->parse_article_template;
}
#print pages to site 
else {	
	foreach my $article_page(@pages){
		#if (defined $article_db{$article_page}){
		$self->{DB_Field}='article';
		$self->unpack_rec($article_db{$article_page});#unpack to {}
		#unless ($self->{'name'}){$self->get_author_info();}
		$self->{'page'}=$self->{'num'};
		$html=$self->parse_article_template;
		$self->print_page($html);#Print static page
		#}
	}
}
&close_article_db;
$self->{'author'}='';
$self->{'name'}='';	
}

sub extract_authors {
#---------------------------------------------------
my $self=shift;
$self->{DB_File}="$self->{'data'}/authors";
$self->{DB_Field}='authors';
$self->_open_db(3, 1);
#map {$self->{$_} if defined $dbm{$_}} keys %dbm;
foreach my $author(keys %dbm){
	if (defined $dbm{$author}){
	$self->{$author}=$dbm{$author};
	}
}
$self->{'author_ext'}=1;
&_close_db;
}	

sub get_author_info {
#-------------------------------------------------
my $self=shift;
my $old_field=$self->{DB_Field};
unless ($self->{'tmp_foto'}){$self->load_templates('article')}
$self->{DB_Field}='authors';
my $author=$self->{'author'};
if ($self->{$author}){
	$self->unpack_rec($self->{$author});
	if ($self->{'foto'}){$self->{'author_foto'}=$self->small_parsing($self->{'tmp_foto'});}
	else {$self->{'author_foto'}='';}
}
else {
	 my @authors=split(/,,,/, $author);
	 my $i=0;
	foreach my $field (@{$db{$self->{DB_Field}}}){
	$self->{$field}=$authors[$i];
	$i++;
	}
#	$self->{'name'}=$author;
#	$self->{'author_foto'}='';
	if ($self->{'foto'}){$self->{'author_foto'}=$self->small_parsing($self->{'tmp_foto'});}
	else {$self->{'author_foto'}='';}
}
$self->{DB_Field}=$old_field;
}	


sub parse_article_template {
#----------------------------------------------------
my $self=shift;
my $tmpl;
unless ((($self->{'tmp_print'})||($self->{'tmp_mail'})||($self->{'tmp_article'}))){$self->load_templates('article');}
#MENU
unless ($self->{'menu_html'}){$self->menu_html;}
#CATEGORY INFO
unless ($self->{'cat_name'}){$self->extract_cat;}

#SITE AND CATEGORY URLS
#unless ($self->{'cat_url'}){$self->{'cat_url'}="$self->{'public_url'}/$self->{'cat_id'}/$self->{'index_page'}";}
unless ($self->{'index_url'}){$self->{'index_url'}="$self->{'public_url'}/$self->{'index_page'}";}

#TEMPLATE
$tmpl=(($self->{'tmp_print'})||($self->{'tmp_mail'})||($self->{'tmp_article'}));
$self->{'print_view'}="$self->{'view_cgi_url'}?id=$self->{'id'}&cat_id=$self->{'cat_id'}&print=$self->{'num'}";
$self->{'email_article'}="$self->{'view_cgi_url'}?id=$self->{'id'}&mail=$self->{'num'}";
#SPAN PAGES
unless ($self->{'span_pages'}){$self->generate_span_pages('article');}
#AUTHOR
unless ($self->{'name'}){$self->get_author_info();}

#META DESCRIPTION:
my $desc=$self->{'preview'};
$desc=~s/<[^>]+>/ /g;
$desc=~s/["'&]//g;
$self->{'meta_description'}=$desc;
undef $desc;

#PARSE:
my $html=$self->small_parsing($tmpl);
$self->{'span_pages'}='';
return  $html;
#end sub
}	

sub parse_index_template {
#----------------------------------------------------
my $self=shift;
my $tmpl;
#CATEGORY INFO
#unless ($self->{'menu_html'}){$self->menu_html;}
if ($self->{'cat_id'} eq 'index'){
	my $title=$self->{'site_title'};
	$self->{'title'}=$title;
	$self->{'cat_name'}=$title;
	$self->{'cat_description'}='';
	$self->{'cat_keywords'}='';
}	
else {
#GREEN LAST EDITION
#	unless ($self->{'cat_name'}){$self->extract_cat;}
	$self->{'title'}=$self->{'cat_name'};
	#$self->extract_cat;
}	
#GREEN LAST EDITION
#unless ($self->{'tmp_index'}){$self->load_templates('index');}
#MENU
#unless ($self->{'menu_html'}){$self->menu_html;}

#SITE AND CATEGORY URLS
unless ($self->{'index_url'}){$self->{'index_url'}="$self->{'public_url'}/$self->{'index_page'}.$self->{'ext'}";}
unless ($self->{'cat_url'}){$self->{'cat_url'}="$self->{'public_url'}/$self->{'cat_id'}/$self->{'index_page'}" if $self->{'cat_id'} ne 'index';}

#TEMPLATE
$tmpl=$self->{'tmp_index'};

#META DESCRIPTION:
my $desc=$self->{'cat_description'};
$desc=~s/<.*?>/ /g;
$desc=~s/["'&]//g;
$self->{'meta_description'}=$desc;
undef $desc;

#SPAN PAGES
unless ($self->{'span_pages'}){$self->generate_span_pages('index');}

#PARSE:
my $html=$self->small_parsing($tmpl);
$self->{'span_pages'}='';
return $html;
#end sub
}	

sub parse_search_template {
#----------------------------------------------------
my $self=shift;
my $tmpl;
#CATEGORY INFO
	my $title="$self->{'site_title'}";
	$self->{'title'}=$title;
	$self->{'cat_name'}=$title;
	
	
unless ($self->{'tmp_search'}){$self->load_templates('search');}
#MENU
unless ($self->{'menu_html'}){$self->menu_html;}

#SITE AND CATEGORY URLS
unless ($self->{'index_url'}){$self->{'index_url'}="$self->{'public_url'}/$self->{'index_page'}.$self->{'ext'}";}

#TEMPLATE
$tmpl=$self->{'tmp_search'};

#SPAN PAGES
unless ($self->{'span_pages'}){$self->generate_span_pages('search');}

#PARSE:
my $html=$self->small_parsing($tmpl);
$self->{'span_pages'}='';
return $html;
#end sub
}	


sub small_parsing {
#--------------------------------------
my $self=shift;
my $tmpl=shift;
$tmpl||=$self->{'tmpl'};
$tmpl =~ s/<%(\w+)%>/$self->{$1}?$self->{$1}:''/gex;
return $tmpl;
}	


sub generate_span_pages {
#---------------------------------------------------
my ($pages, $span, $how_pages, $url_next, $num);
my $self=shift;
my $option=shift;

my $entry_per_page=$self->{'entry_per_page'};
#INDEX:
if ($option eq 'index'){
	$num=$self->{'page'};
	$num||=1;
	#BASE URL
	unless ($self->{'static_pages'}){
		$self->{'base_url'}="$self->{'view_cgi_url'}?cat_id=$self->{'cat_id'}&page=";
	}
	#Number pages
	my $num_recs=$self->{'num_keys'};
	$how_pages = int ($num_recs/$entry_per_page);
	++$how_pages unless (($how_pages*$entry_per_page) == $num_recs);
}
#SEARCHING
elsif ($option eq 'search'){
	 $num=$self->{'page'};
	 $num||=1;
	$self->{'base_url'}="$self->{'view_cgi_url'}?$self->{'terms'}&page=";
	#Number pages
	my $num_recs=$self->{'num_keys'};
	$how_pages = int ($num_recs/$entry_per_page);
	++$how_pages unless (($how_pages*$entry_per_page) == $num_recs);
}
#ARTICLE	
else {	
	#BASE URL
	if ($self->{'static_pages'}){$self->{'base_url'}="$self->{'public_url'}/$self->{'cat_id'}/$self->{'id'}".'_';}
	else {$self->{'base_url'}="$self->{'view_cgi_url'}?id=$self->{'id'}&cat_id=$self->{'cat_id'}&page=";}
	$how_pages=$self->{'pages'};
	$num||=$self->{'num'};
}

#BUILD PAGE INDEX
for (my $i =1; $i<=$how_pages; $i++){ 
#HTML SPAN PAGES:
	#....ARTICLE
	if ($option eq 'article'){
		if ($self->{'static_pages'}){$url_next=$self->{'base_url'}."$i.$self->{'ext'}";}
		else {$url_next=$self->{'base_url'}.$i;}
	}
	#....INDEX
	else {
		if (($option eq 'index')&&($i==1)){$url_next= ($self->{'cat_id'} eq 'index')? "$self->{'public_url'}/$self->{'index_page'}" : "$self->{'public_url'}/$self->{'cat_id'}/$self->{'index_page'}";}
		else {
			if (($option eq 'search')||(!($self->{'static_pages'}))){$url_next="$self->{'base_url'}$i";}
			#Static Index Pages
	  		else {$url_next="$self->{'cat_pages_url'}/$i$self->{'index_page'}";}
	    	
	    }
	}	
	
	if (($num != $i)){$pages .= qq~ <a href="$url_next" class="span"> $i </a>~;}
	#IF ACTIVE PAGE:
	else {$pages .= qq~ <b>$i</b> ~;}
}
#
$self->{'span_pages'}=$pages;
return $pages;
#end sub
}

sub extract_cat {
#---------------------------------------------------
my $self=shift;
my $cat_id=$self->{'cat_id'};
my $field=$self->{DB_Field};
$self->{DB_Field}='categories';
unless ($self->{'cat_extr'}){
	$self->{DB_File}="$self->{'data'}/categories";
	$self->_open_db(3, 1);
	foreach my $key (keys %dbm){
		$self->{"cat_$key"}=$dbm{$key} if defined $dbm{$key};
	}	
	&_close_db;
	$self->{'cat_extr'}=1;
	$self->{'cat_id'}=$cat_id;
}

if ( $cat_id eq 'index'){
	$self->{'template'}='tmp-main';
	$self->{'cat_url'}="$self->{'public_url'}/$self->{'index_page'}";
	$self->{'description'} = '';
}
else {
#Extract Category info now..
	$self->unpack_rec($self->{"cat_$cat_id"});
	$self->{'cat_url'}="$self->{'public_url'}/$cat_id/$self->{'index_page'}";
}
$self->{DB_Field}=$field;	
#end sub
}	

sub load_templates {
#----------------------------------------------------
my $self=shift;
my $option=shift;
$self->{'template'}||$self->extract_cat;
if ($option eq 'article'){
	$self->extract_template('article', 'foto');
	$self->parse_include('article');
}
elsif($option eq 'print'){
	$self->extract_template('print', 'foto');
	$self->parse_include('print');
}
elsif($option eq 'mail'){
	$self->extract_template('mail', 'foto');
	$self->parse_include('mail');
}	
elsif($option eq 'related'){$self->extract_template('related');}
elsif($option eq 'search'){
	$self->{'template'}='tmp-main';
	$self->extract_template('search', 'preview');
	$self->parse_include('search');
	} 
else {
	$self->extract_template('index','preview', 'news');
	$self->parse_include('index');
}
#end sub
}	

sub parse_include {
#-------------------------------------------------
my $self=shift;
my ($option, $templ, $file);
$option=shift;
$templ=$self->{"tmp_$option"};
if ($templ =~/<%include=[\w\-\.]+%>/){
	while ($templ =~/(<%include=([-\w\.]+)%>)/g){
		 my $tag=$1;
		 if ($self->{"inc_$2"}){$file=$self->{"inc_$2"};}
		 else {
	 		$file=$self->load_tempfile("$self->{'tmpl_dir'}/include/$2");
	 		$self->{"inc_$2"}=$file;
		 } 
	 	$templ =~ s/$tag/$file/ if $tag&&$file;
	}
}	
$self->{"tmp_$option"}=$templ;
}

sub extract_template {
#--------------------------------------------------
my $self=shift;
foreach my $tmp(@_){
	$self->{"tmp_$tmp"}=$self->load_tempfile("$self->{'tmpl_dir'}/$self->{'template'}/$tmp.txt");
}
}

sub load_tempfile {
#-----------------------------------------------------
my $self=shift;
my $src=shift;
my $templ;
open ('TMPL', "<$src")||croak("Could not open $src, reason:$!");
if ($USE_FLOCK){flock('TMPL',1);}
while(<TMPL>){$templ .=$_;}
close TMPL;
return $templ;
}	

sub menu_html {
#---------------------------------------------------
my ($menu, $drop_list);
my $self=shift;
my $option=shift;
if ($option||(! -e "$self->{'data'}/$self->{'template'}-menu.txt")||(! -e "$self->{'data'}/$self->{'template'}-drop_list.txt")){
	($menu, $drop_list)=$self->generate_menu;
}
else {
	$menu=$self->load_tempfile("$self->{'data'}/$self->{'template'}-menu.txt");
	$drop_list=$self->load_tempfile("$self->{'data'}/$self->{'template'}-drop_list.txt");
}
$self->{'menu_html'}=$menu;
$self->{'drop_list'}=$drop_list;
#end sub
}	


sub generate_menu {
#---------------------------------------------------
my ($html, $drop_list, $cat_id, $tmpl, $tmpl_list, @keys);
my $self=shift;
$cat_id=$self->{'cat_id'};


$tmpl=$self->load_tempfile("$self->{'tmpl_dir'}/$self->{'template'}/menu_row.txt");
$tmpl_list=$self->load_tempfile("$self->{'tmpl_dir'}/$self->{'template'}/drop_list.txt");

$self->{DB_File}=$self->{'data'}.'/categories';
$self->{DB_Field}='categories';
#$self->_open_db(3,1);


$self->{'index_url'}="$self->{'public_url'}/$self->{'index_page'}";
unless($self->{'cat_extr'}){$self->extract_cat;}
foreach my $rec(grep {/cat_\d+/} keys %{$self}){
 	my $key = $rec;
 	$key=~s/cat_//;
 	push(@keys, $key);
}	
foreach my $key(sort {$a<=>$b} @keys){
	#if (defined $self->{$key}){
	$self->{'cat_id'}=$key;
	$self->{'cat_url'}="$self->{'public_url'}/$key/$self->{'index_page'}";
	$self->unpack_rec($self->{"cat_$key"});
	$html .= $self->small_parsing($tmpl);
	$drop_list .= qq~<option value=$key>$self->{'cat_name'}~;
	#$self->{"cat_$key"}=$dbm{$key} unless ($self->{'cat_extr'});
	#}

}
#Memory remains!
#Load category info
#$self->{'cat_extr'}=1;
#&_close_db;	
$self->{'cat_id'}=$cat_id;
$self->unpack_rec($self->{"cat_$cat_id"}) if $cat_id ne 'index';


$self->{'drop_list'}=$drop_list;
$drop_list=$self->small_parsing($tmpl_list);
#PRINT menu.txt
open (MENU, ">$self->{'data'}/$self->{'template'}-menu.txt")||croak("Could not open $self->{'data'}/$self->{'template'}menu.txt, reason:$!");
if ($USE_FLOCK){flock(MENU,2);}
print MENU $html;
close (MENU)||croak("Could not close $self->{'data'}/$self->{'template'}-menu.txt, reason:$!");
#PRINT drop_list.txt
open (DROPLIST, ">$self->{'data'}/$self->{'template'}-drop_list.txt")||croak("Could not open $self->{'data'}/menu.txt, reason:$!");
if ($USE_FLOCK){flock(DROPLIST,2);}
print DROPLIST $drop_list;
close (DROPLIST)||croak("Could not close $self->{'data'}/$self->{'template'}-drop-list.txt, reason:$!");

return $html, $drop_list;
#end sub
}	


sub print_page {
#---------------------------------------------------
my $self=shift;
my $html=shift;
unless (-e "$self->{'public_dir'}/$self->{'cat_id'}"){
	mkdir("$self->{'public_dir'}/$self->{'cat_id'}", 0777) or croak("Can't mkdir $self->{'public_dir'}/$self->{'cat_id'} reason: $!");
	chmod (0777, "$self->{'public_dir'}/$self->{'cat_id'}");
	}
my $path_to_page="$self->{'public_dir'}/$self->{'cat_id'}/$self->{'id'}"."_"."$self->{'num'}.$self->{'ext'}";
open (PAGE, ">$path_to_page")||croak("Could not open $path_to_page, reason: $!");
if ($USE_FLOCK){flock(PAGE,2);}
print PAGE $html;
close(PAGE)||croak("Could not close $path_to_page, reason: $!");
}

sub build_category {
#----------------------------------------------------
my ($cat_id, $path_to_index, @keys);
my $self=shift;
$cat_id=shift;
$self->{'cat_id'}=$cat_id;
#Check categories public path
$path_to_index="$self->{'public_dir'}/$cat_id";
if (!(-e $path_to_index)){
	mkdir($path_to_index, 0777) or croak("Can't mkdir $path_to_index, reason: $!");
	chmod(0777, $path_to_index) or croak("Can't mkdir $path_to_index, reason: $!");
}

$self->extract_cat;#1
$self->load_templates('article');#Load templates for article's pages
$self->menu_html(1);#generate html menu
$self->{'cat_id'}=$cat_id;
$self->{DB_File}="$self->{'data'}/$cat_id";
$self->{DB_Field}='index';
$self->_open_db(3,1);
	@keys= sort {$b <=> $a} map {$_ if defined $dbm{$_}} keys %dbm;
	&_close_db;
if ($self->{'static_pages'}){
	foreach my $key (@keys){
		$self->build_article($key);
	}
}
$self->{'cat_id'}=$cat_id;
$self->extract_cat;#2
#Print Index
$self->print_index_page(@keys);
}			

sub print_index_page {
#------------------------------------------------
my ($path_to_index, $num, $cat_id, $how, $page, $how_pages, @keys, $index_page);
my $self=shift;
@keys=@_;
$num=$#keys+1;
$cat_id =$self->{'cat_id'};
if ($self->{'cat_id'} eq 'index'){
	$self->{'cat_pages_url'}="$self->{'public_url'}";
	$self->{'template'}='tmp-main';
}
else {
	$self->{'cat_pages_url'}="$self->{'public_url'}/$cat_id";
}	
	

#Count Pages
$how=$self->{'entry_per_page'};

$how_pages = int ($num/$how);
++$how_pages unless (($how_pages*$how) == $num);   

foreach my $i (1..$how_pages){
	$self->{'page'}=$i;
	my $page = $i;
	
	#From Entry -> To Entry
	my $start=(($how*($page-1))||0);
	if ($start>($num-1)){$start=0;}
	my $end=$start+$how-1;
	if ($end>($num-1)){$end=($num-1);}
	
	#Index Name
	if ($i==1){$index_page = $self->{'index_page'};}
	else { $index_page = $i.$self->{'index_page'};}
        
        #build url
        if ($self->{'cat_id'} eq 'index'){
		$path_to_index="$self->{'public_dir'}/$index_page";
		
	}
	else {
		$path_to_index="$self->{'public_dir'}/$cat_id/$index_page";
	}
	
	#Build page
	$page=$self->build_index($num,@keys[$start..$end]);
	
	#PRINT PAGE
	open(INDEX, ">$path_to_index")||croak("Can't open $path_to_index, reason: $!");
	if ($USE_FLOCK){flock(INDEX,2);}
	print INDEX $page;
	close(INDEX)||croak("Could not close $path_to_index, reason: $!");
	
	#END if dynamic pages.
	last unless ($self->{'static_pages'});
}

$self->print_news($self->{'cat_id'}, $self->{'how_news'});
}	

sub print_news {
#--------------------------------------------------
my ($cat, $how_news, $news_js, $html, $news_txt, $use_txt, %news);
my $self=shift;
$cat=shift;
$how_news=shift;
$use_txt=$self->{'txt_news'};
$self->{DB_File}="$self->{'data'}/$cat";
$self->{DB_Field}='index';
unless($self->{'tmp_news'}){$self->{'tmp_news'}=$self->load_tempfile("$self->{'tmpl_dir'}/tmp-main/news.txt");}
%news=$self->get_nn_recs($how_news);
foreach my $key(sort {$b <=> $a} keys %news){
	$self->unpack_rec($news{$key});
	$self->get_author_info();
		if ($self->{'static_pages'}){$self->{'article_url'}="$self->{'public_url'}/$self->{'cat_id'}/$key"."_1.$self->{'ext'}";}
		else {$self->{'article_url'}=$self->{'view_cgi_url'}."?id=$key&cat_id=$self->{'cat_id'}&page=1";}
	$html=$self->small_parsing($self->{'tmp_news'});
	$news_txt .= "$html\n" if  $use_txt;
	$html=~ s/"/\\"/g;
	$html=~ s/[\n\r]//g;
	$html=~ s/'/\'/g;
	$news_js .= qq~document.write("$html");\n~;
}
#CHECK DIRS:
if (!(-e "$self->{'public_dir'}/news")){
	mkdir("$self->{'public_dir'}/news", 0777) or croak("Can't mkdir $self->{'public_dir'}/news, reason: $!");
	chmod(0777, "$self->{'public_dir'}/news") or croak("Can't chmod $self->{'public_dir'}/news, reason: $!");
}
#PRINT in *.js
if ($news_js){
	open (NEWS, ">$self->{'public_dir'}/news/$cat.js") or croak("Can't open NEWS, reason: $!");
	if ($USE_FLOCK){flock(NEWS, 2);}
	print NEWS $news_js;
	close NEWS;
}	
#Print in *.txt
if ($news_txt){
	open (NEWSTXT, ">$self->{'public_dir'}/news/$cat.txt") or croak("Can't open NEWSTXT, reason: $!");
	print NEWSTXT $news_txt;
	close NEWSTXT;
}
}	
	
sub build_index {
#----------------------------------------------------
my ($html_index, $cat_id, @keys, %cat_list);
my $self=shift;
$self->{'num_keys'}=shift;
#if (@_){@keys= sort {$b <=> $a} @_;}
@keys=@_;
$cat_id=$self->{'cat_id'};
unless ($self->{'tmp_index'}){$self->load_templates('index');}#GREEN LAST EDITION!

$self->extract_authors;
$self->generate_span_pages('index');
unless ($self->{'menu_html'}){$self->menu_html;}
%cat_list=$self->build_cat_list;#Build hash: cat_id => cat_name
#unless (%dbm){
	#Now open Main Index DB:
	#$self->{DB_File}="$self->{'data'}/index";
	$self->{DB_File}="$self->{'data'}/$cat_id";
	$self->{DB_Field}='index';
	$self->_open_db(3,1);
#}
##GREEN LAST EDITION!
#unless ($self->{'tmp_index'}){$self->load_templates('index');}
if (@keys){
foreach my $key(@keys){
		if (defined $dbm{$key}){
		$self->unpack_rec($dbm{$key});
		$self->get_author_info();
		
		if ($self->{'status'} ne 'ok'){next;}
		
		$self->{'cat_name'}=$cat_list{"cat_$self->{'cat_id'}"};#Get category name
		$self->{'cat_url'}="$self->{'public_url'}/$self->{'cat_id'}/$self->{'index_page'}";#Get category url
		
		if ($self->{'static_pages'}){$self->{'article_url'}="$self->{'public_url'}/$self->{'cat_id'}/$key"."_1.$self->{'ext'}";}
		else {$self->{'article_url'}=$self->{'view_cgi_url'}."?id=$key\&cat_id=$self->{'cat_id'}\&page=1";}
		
		$html_index .= $self->small_parsing($self->{'tmp_preview'});#Parse article preview
		}
	}	
}
else {$html_index='';}	
$self->{'content'}=$html_index;
&_close_db;
undef @keys;
$self->{'cat_id'}=$cat_id;
#unless ($self->{'menu_html'}){$self->menu_html;}
$self->extract_cat;#ReLoad category info
return $self->parse_index_template;
#end sub
}	

sub build_index_search {
#---------------------------------------------------
my ($html_index,$art_id, $art_page,$title, @keys, %cat_list);
my $self=shift;
$self->{'terms'}=shift;
$self->{'num_keys'}=shift;
$self->load_templates('search');
$self->extract_authors;
@keys=@_;
$self->generate_span_pages('search');
%cat_list=$self->build_cat_list;#Build hash: cat_id => cat_name
#unless (%dbm){
	#Now open Main Index DB:
	$self->{DB_File}="$self->{'data'}/index";
	$self->{DB_Field}='index';
	$self->_open_db(3,1);
#}
$self->{'cat_id'}='search';	
#unless ($self->{'tmp_index'}){$self->load_templates('index');}
foreach my $key(@keys){
	($art_id, $art_page)=split(/_/, $key) if defined $key;
	if (defined $dbm{$art_id}){
	$self->unpack_rec($dbm{$art_id});
	$self->get_author_info();
	$title=$self->{'title'};
	$self->{'title'}=$title." <sub>($art_page)</sub>"; 
	if ($self->{'status'} ne 'ok'){next;}
	$self->{'cat_name'}=$cat_list{"cat_$self->{'cat_id'}"};#Get category name
	$self->{'cat_url'}="$self->{'public_url'}/$self->{'cat_id'}/$self->{'index_page'}";#Get category url
		if ($self->{'static_pages'}){$self->{'article_url'}="$self->{'public_url'}/$self->{'cat_id'}/$art_id"."_$art_page.$self->{'ext'}";}
		else {$self->{'article_url'}=$self->{'view_cgi_url'}."?id=$art_id&cat_id=$self->{'cat_id'}\&page=$art_page";}
	$html_index .= $self->small_parsing($self->{'tmp_preview'});#Parse article preview
}
}	
$self->{'content'}=$html_index;	
&_close_db;
undef @keys;
$self->{'template'}='tmp-main';#I'm Englishman in New York!
return $self->parse_search_template;
#end sub
}	




sub build_cat_list {
#----------------------------------------------------
my $self=shift;
my $option=shift;
unless ($self->{'cat_extr'}){$self->extract_cat;}
$self->{DB_Field}='categories';
my @keys= grep (/cat_\d+/, keys %{$self});
my %cats=();
foreach my $key (@keys){
	$self->unpack_rec($self->{$key});
	$cats{$key}=$self->{'cat_name'};
	}
if ($option){$self->unpack_rec($self->{$option});}
return %cats;
#end sub	
}

sub related_links {
#----------------------------------------------------
my ($related, @list, %cat_list);
my $self=shift;
$self->{'cat_id'}=shift;
@list=@_;
$self->load_templates('related');
%cat_list=$self->build_cat_list($self->{'cat_id'});#Build hash: cat_id => cat_name
$self->{DB_File}="$self->{'data'}/index";
$self->{DB_Field}='index';
$self->_open_db(3,1);
foreach my $rec(@list){
	unless (defined $dbm{$rec}){next;}
	$self->unpack_rec($dbm{$rec});
	$self->{'cat_name'}=$cat_list{$self->{'cat_id'}};#Get category name
	$self->{'cat_url'}="$self->{'public_url'}/$self->{'cat_id'}/$self->{'index_page'}";#Get category url
	#Build URL:
	$self->{'article_url'}=$self->{'view_cgi_url'}."?goto=$rec";
	$related .=$self->small_parsing($self->{'tmp_related'});
}		
&_close_db;
return $related;	
}	

	
sub article_open {
#----------------------------------------------------
my $self=shift;
my $file="$self->{'data'}/$self->{'cat_id'}/$self->{'id'}.dat";
my $lock="$self->{'data'}/$self->{'cat_id'}/$self->{'id'}.lock";
if ($USE_FLOCK){
	open (ARTDATA, ">$lock") or croak("Can't open ARTDATA $lock, reason: $!");
	flock(ARTDATA, 1) or croak("Can't flock DATABASE, reason: $!");
}
 tie (%article_db, 'DB_File', $file, O_RDONLY, 0666, $DB_HASH)||croak ("Can not tie \%article_db $file, reason: $!");
}

sub close_article_db {
#---------------------------------------------------
untie %article_db;
close ARTDATA if $USE_FLOCK;
}	

####################################################
#                Search Methods                    #
####################################################

sub add_to_index {
#------------------------------------
my $self=shift;
my $id=shift;
my %words=@_;
$self->_open_db(2, 2);
foreach my $word(keys %words){
	if (defined $dbm{$word}){
		$dbm{$word}=~s/;$id,\d+//og;
		$dbm{$word} .=";$id".",$words{$word}";
		}
	else {$dbm{$word} =";$id".",$words{$word}";}
}	
&_close_db;
}


sub delete_from_index {
#---------------------------------------------------
my $self=shift;
my $id=shift;
my %words=@_;
$self->_open_db(2, 2);
foreach my $word(keys %words){
	if (defined $dbm{$word}){
	$dbm{$word}=~s/;$id,\d+//og;
	delete $dbm{$word} unless ($dbm{$word});
	}
}	
&_close_db;
}

sub delete_from_index_all {
#---------------------------------------------------
my $self=shift;
my $id=shift;
my %words=@_;
$self->_open_db(2, 2);
foreach my $word(keys %words){
	if (defined $dbm{$word}){
		$dbm{$word}=~s/;$id\w+,\d+//og;
		delete $dbm{$word} unless ($dbm{$word});
	}
}	
&_close_db;
}


sub search {
#---------------------------------------------------
my $self=shift;
my @terms=@_;
my @result=();
$self->_open_db(3, 1);
foreach my $term(@terms){
	if (defined $dbm{$term}){push(@result,$dbm{$term});}
	else {
		#searching all keys..
		eval 'foreach my $key (keys %dbm){push(@result, $dbm{$key}) if $key =~ m/$term/o;}';
		if ($@){croak("SEARCH ERROR: $@!");}#if eval error 
	}
}
&_close_db;	
return @result;
}	

####################################################
#            Private Service Methods               #
####################################################

sub _open_db {
#---------------------------------------------------	
my $self=shift;
my $option=shift;
my $flock_option=shift;
my $file=$self->{DB_File}.'.dat';
my $lock=$self->{DB_File}.'.lock';

if ($USE_FLOCK){
	open (DATABASE, ">$lock") or croak("Can't open DATABASE, reason: $!");
	flock(DATABASE, $flock_option) or croak("Can't flock DATABASE, reason: $!");
}

if ($option==1){
#	unless($DB_HASH->{'nelem'}){$DB_HASH->{'nelem'}=64;}
	tie (%dbm, 'DB_File', $file, O_CREAT|O_RDWR, 0666, $DB_HASH)||croak ("Can not tie \%dbm $self->{DB_File} mode=$option, reason: $!");
}
elsif ($option==2){
	tie (%dbm, 'DB_File', $file, O_RDWR, 0666, $DB_HASH)||croak ("Can not tie \%dbm $self->{DB_File} mode=$option, reason: $!");
}
elsif ($option==3){
	tie (%dbm, 'DB_File', $file, O_RDONLY, 0666, $DB_HASH)||croak ("Can not tie \%dbm $self->{DB_File} mode=$option, reason: $!");
}

#Now open Filehandle
#open (DATABASE, "+<&=$fd")||croak("Can not open DATABASE $fd, reason: $!");

#...and flock dbm file. 
#WARNING: this flock() technique has been shown to be fundamentally
#flawed! For more information see DB_File Pod "Locking: The Trouble with fd"!
#flock(DATABASE, $flock_option)||croak ("Can not flock DATABASE, reason: $!");
#return %dbm;
}

sub _close_db {
#---------------------------------------------------
untie %dbm;
close DATABASE if $USE_FLOCK;
}	


sub _self_fields {
#------------------------------------------------
my $self=shift;
my $i=0;
foreach my $field (@{$db{$self->{DB_Field}}}){
$_[$i]||='';
$self->{$field}=$_[$i];
$i++;
}
}

###################################################
#             Pack/Unpack Routings                #
###################################################

sub pack_rec {
#--------------------------------------------------
my $self=shift;
my (@rec);
my @vals=@_;
unless ($#_ == $#{$db{$self->{DB_Field}}}){croak ("Not found some data for fields $self->{DB_Field}!")}
foreach my $val(@vals){
	$val=~s/\Q$delim\E/$ascii_delim/og;
	push (@rec, $val);
}	 
return join($delim, @rec);
}

sub pack_fields {
#-------------------------------------------------
my $self=shift;
my @rec=map($self->{$_}, @{$db{$self->{DB_Field}}}); 
return $self->pack_rec(@rec);
}
	

sub unpack_rec {
#-------------------------------------------------
my $self=shift;
my $pack_rec=shift;
my @rec=split (/\Q$delim\E/, $pack_rec) if $pack_rec;
$self->_self_fields(@rec);
} 


sub unpack_to_hash {
#-----------------------------------------------
my $self=shift;
$self->unpack_rec($_[0]);
return $self->self_to_hash;
}	

sub unpack_field {
#------------------------------------------------
my $self=shift;
my $recs=shift;
my $field=shift;
my %all_recs=$self->unpack_to_hash($recs);
return 	$all_recs{$field};
}

sub DESTROY {
#----------------------------------------------
}	

			
1;		
	

